' Identische Titel lschen
'
' Das Skript lscht alle doppelten, identischen Titel, deren
' Audiodateien von mehreren Eintrgen Ihrer iTunes-Datenbank
' verwendet werden. Wiedergabelisten, die diese gelschten Titel
' beinhalteten, werden automatisch mit der nicht gelschten
' Originaldatei befllt. 
'
' (c) 2005 Gerald Erdmann
'
' Skript aus dem Buch "iPod + iTunes", erscheinen bei O'Reilly
' Weitere Details finden Sie unter http://www.ipodbuch.de.
' Fr etwaige Fehler oder Datenverluste wird keine Garantie
' bernommen. Benutzung auf eigene Gefahr!
'
' Zur Installation das Skript an eine beliebige Stelle kopieren.
' Das Skript kann nicht direkt aus iTunes heraus aufgerufen werden,
' sondern wird direkt aus dem Windows Explorer gestartet.
'
' Version 1.0  Okt. 2005  Erste Version
'

dim iTunes, iTunesTracks
dim maxTracks, currentTrack
dim currentLocation
dim identicalTrack, identicalTracks (), identicalTracksCount
dim identicalIDs (), identicalIDsCount
dim foundTrack, foundIdenticalTrack
dim foundLocations (), foundLocationsCount, locationfound
dim mappingTracks (), mappingIDs (), mappingIDsCount
dim currentIDs (), currentIDsCount
dim countDeletes, counter


set iTunes = WScript.CreateObject ("iTunes.Application")
set iTunesTracks = iTunes.LibraryPlaylist.Tracks

maxTracks = iTunesTracks.count
redim foundLocations (maxTracks)
redim identicalTracks (maxTracks)
redim identicalIDs (maxTracks)
redim mappingTracks (maxTracks)
redim mappingIDs (maxTracks)

countDeletes = 0
identicalTracksCount = 0
identicalIDsCount = 0
foundLocationsCount = 0
mappingTracksCount = 0
mappingIDsCount = 0
for currentTrack = 1 to maxTracks
  currentLocation = iTunesTracks.Item (currentTrack).Location
  locationfound = 0
  for foundTrack = 1 to foundLocationsCount
    if foundLocations(foundTrack) = currentLocation then
      mappingTracksCount = mappingTracksCount + 1
      mappingTracks(mappingTracksCount) = foundTrack
      mappingIDsCount = mappingIDsCount + 1
      mappingIDs(mappingIDsCount) = iTunesTracks.Item (foundTrack).TrackDatabaseID
      countDeletes = countDeletes + 1
      locationfound = 1
      exit for
    end if
  next
  if locationfound = 1 then
    identicalTracksCount = identicalTracksCount + 1
    identicalTracks(identicalTracksCount) = currentTrack
    identicalIDsCount = identicalIDsCount + 1
    identicalIDs(identicalIDsCount) = iTunesTracks.Item (currentTrack).TrackDatabaseID
  else
    foundLocationsCount = foundLocationsCount + 1
    foundLocations(foundLocationsCount) = currentLocation
  end if
next

for counter = 1 to iTunes.LibrarySource.Playlists.Count
  set currentPlaylist = iTunes.LibrarySource.Playlists.Item (counter)
  if currentPlaylist.Kind = 2 then
    if currentPlaylist.Smart = 0 and currentPlaylist.Shared = 0 then
      currentIDsCount = 0
      maxCurrentTrack = currentPlaylist.Tracks.Count
      redim currentIDs (maxCurrentTrack)
      for currentTrack = 1 to maxCurrentTrack
        currentIDsCount = currentIDsCount + 1
        currentIDs(currentIDsCount) = currentPlaylist.Tracks.Item (currentTrack).TrackDatabaseID
      next
      for identicalTrack = 1 to identicalTracksCount
        foundIdenticalTrack = 0
        for currentTrack = 1 to maxCurrentTrack
          currentID = currentIDs(currentTrack)
          if currentID = identicalIDs(identicalTrack) then
            foundIdenticalTrack = 1
          elseif currentID = mappingIDs(identicalTrack) then
            foundIdenticalTrack = 0
            exit for
          end if
        next
        if foundIdenticalTrack = 1 then
          set currentTrack = iTunesTracks.Item (mappingTracks(identicalTrack))
          currentPlaylist.AddTrack (currentTrack)
        end if
      next
    end if
  end if
next

for identicalTrack = identicalTracksCount to 1 step -1
   iTunesTracks.Item (identicalTracks(identicalTrack)).Delete
next

if countDeletes = 0 then
  WScript.Echo "Es wurden keine identischen Titel gefunden!"
elseif countDeletes = 1 then
  WSCript.Echo "Es wurde ein identischer Titel gelscht!"
else
  WScript.Echo "Es wurden " & countDeletes & " identische Titel gelscht!"
end if
